deps.mk 21 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623
  1. # Copyright (c) 2013-2016, Loïc Hoguin <essen@ninenines.eu>
  2. # This file is part of erlang.mk and subject to the terms of the ISC License.
  3. .PHONY: distclean-deps
  4. # Configuration.
  5. ifdef OTP_DEPS
  6. $(warning The variable OTP_DEPS is deprecated in favor of LOCAL_DEPS.)
  7. endif
  8. IGNORE_DEPS ?=
  9. export IGNORE_DEPS
  10. APPS_DIR ?= $(CURDIR)/apps
  11. export APPS_DIR
  12. DEPS_DIR ?= $(CURDIR)/deps
  13. export DEPS_DIR
  14. REBAR_DEPS_DIR = $(DEPS_DIR)
  15. export REBAR_DEPS_DIR
  16. dep_name = $(if $(dep_$(1)),$(1),$(if $(pkg_$(1)_name),$(pkg_$(1)_name),$(1)))
  17. dep_repo = $(patsubst git://github.com/%,https://github.com/%, \
  18. $(if $(dep_$(1)),$(word 2,$(dep_$(1))),$(pkg_$(1)_repo)))
  19. dep_commit = $(if $(dep_$(1)_commit),$(dep_$(1)_commit),$(if $(dep_$(1)),$(word 3,$(dep_$(1))),$(pkg_$(1)_commit)))
  20. ALL_APPS_DIRS = $(if $(wildcard $(APPS_DIR)/),$(filter-out $(APPS_DIR),$(shell find $(APPS_DIR) -maxdepth 1 -type d)))
  21. ALL_DEPS_DIRS = $(addprefix $(DEPS_DIR)/,$(foreach dep,$(filter-out $(IGNORE_DEPS),$(BUILD_DEPS) $(DEPS)),$(call dep_name,$(dep))))
  22. ifeq ($(filter $(APPS_DIR) $(DEPS_DIR),$(subst :, ,$(ERL_LIBS))),)
  23. ifeq ($(ERL_LIBS),)
  24. ERL_LIBS = $(APPS_DIR):$(DEPS_DIR)
  25. else
  26. ERL_LIBS := $(ERL_LIBS):$(APPS_DIR):$(DEPS_DIR)
  27. endif
  28. endif
  29. export ERL_LIBS
  30. export NO_AUTOPATCH
  31. # Verbosity.
  32. dep_verbose_0 = @echo " DEP " $(1);
  33. dep_verbose_2 = set -x;
  34. dep_verbose = $(dep_verbose_$(V))
  35. # Core targets.
  36. ifdef IS_APP
  37. apps::
  38. else
  39. apps:: $(ALL_APPS_DIRS)
  40. ifeq ($(IS_APP)$(IS_DEP),)
  41. $(verbose) rm -f $(ERLANG_MK_TMP)/apps.log
  42. endif
  43. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  44. # Create ebin directory for all apps to make sure Erlang recognizes them
  45. # as proper OTP applications when using -include_lib. This is a temporary
  46. # fix, a proper fix would be to compile apps/* in the right order.
  47. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  48. mkdir -p $$dep/ebin || exit $$?; \
  49. done
  50. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  51. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/apps.log; then \
  52. :; \
  53. else \
  54. echo $$dep >> $(ERLANG_MK_TMP)/apps.log; \
  55. $(MAKE) -C $$dep IS_APP=1 || exit $$?; \
  56. fi \
  57. done
  58. endif
  59. ifneq ($(SKIP_DEPS),)
  60. deps::
  61. else
  62. ifeq ($(ALL_DEPS_DIRS),)
  63. deps:: apps
  64. else
  65. deps:: $(ALL_DEPS_DIRS) apps
  66. ifeq ($(IS_APP)$(IS_DEP),)
  67. $(verbose) rm -f $(ERLANG_MK_TMP)/deps.log
  68. endif
  69. $(verbose) mkdir -p $(ERLANG_MK_TMP)
  70. $(verbose) for dep in $(ALL_DEPS_DIRS) ; do \
  71. if grep -qs ^$$dep$$ $(ERLANG_MK_TMP)/deps.log; then \
  72. :; \
  73. else \
  74. echo $$dep >> $(ERLANG_MK_TMP)/deps.log; \
  75. if [ -f $$dep/GNUmakefile ] || [ -f $$dep/makefile ] || [ -f $$dep/Makefile ]; then \
  76. $(MAKE) -C $$dep IS_DEP=1 || exit $$?; \
  77. else \
  78. echo "Error: No Makefile to build dependency $$dep."; \
  79. exit 2; \
  80. fi \
  81. fi \
  82. done
  83. endif
  84. endif
  85. # Deps related targets.
  86. # @todo rename GNUmakefile and makefile into Makefile first, if they exist
  87. # While Makefile file could be GNUmakefile or makefile,
  88. # in practice only Makefile is needed so far.
  89. define dep_autopatch
  90. if [ -f $(DEPS_DIR)/$(1)/erlang.mk ]; then \
  91. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  92. $(call dep_autopatch_erlang_mk,$(1)); \
  93. elif [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  94. if [ 0 != `grep -c "include ../\w*\.mk" $(DEPS_DIR)/$(1)/Makefile` ]; then \
  95. $(call dep_autopatch2,$(1)); \
  96. elif [ 0 != `grep -ci rebar $(DEPS_DIR)/$(1)/Makefile` ]; then \
  97. $(call dep_autopatch2,$(1)); \
  98. elif [ -n "`find $(DEPS_DIR)/$(1)/ -type f -name \*.mk -not -name erlang.mk -exec grep -i rebar '{}' \;`" ]; then \
  99. $(call dep_autopatch2,$(1)); \
  100. else \
  101. $(call erlang,$(call dep_autopatch_app.erl,$(1))); \
  102. fi \
  103. else \
  104. if [ ! -d $(DEPS_DIR)/$(1)/src/ ]; then \
  105. $(call dep_autopatch_noop,$(1)); \
  106. else \
  107. $(call dep_autopatch2,$(1)); \
  108. fi \
  109. fi
  110. endef
  111. define dep_autopatch2
  112. if [ -f $(DEPS_DIR)/$1/src/$1.app.src.script ]; then \
  113. $(call erlang,$(call dep_autopatch_appsrc_script.erl,$(1))); \
  114. fi; \
  115. $(call erlang,$(call dep_autopatch_appsrc.erl,$(1))); \
  116. if [ -f $(DEPS_DIR)/$(1)/rebar -o -f $(DEPS_DIR)/$(1)/rebar.config -o -f $(DEPS_DIR)/$(1)/rebar.config.script ]; then \
  117. $(call dep_autopatch_fetch_rebar); \
  118. $(call dep_autopatch_rebar,$(1)); \
  119. else \
  120. $(call dep_autopatch_gen,$(1)); \
  121. fi
  122. endef
  123. define dep_autopatch_noop
  124. printf "noop:\n" > $(DEPS_DIR)/$(1)/Makefile
  125. endef
  126. # Overwrite erlang.mk with the current file by default.
  127. ifeq ($(NO_AUTOPATCH_ERLANG_MK),)
  128. define dep_autopatch_erlang_mk
  129. echo "include $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk" \
  130. > $(DEPS_DIR)/$1/erlang.mk
  131. endef
  132. else
  133. define dep_autopatch_erlang_mk
  134. :
  135. endef
  136. endif
  137. define dep_autopatch_gen
  138. printf "%s\n" \
  139. "ERLC_OPTS = +debug_info" \
  140. "include ../../erlang.mk" > $(DEPS_DIR)/$(1)/Makefile
  141. endef
  142. define dep_autopatch_fetch_rebar
  143. mkdir -p $(ERLANG_MK_TMP); \
  144. if [ ! -d $(ERLANG_MK_TMP)/rebar ]; then \
  145. git clone -q -n -- https://github.com/rebar/rebar $(ERLANG_MK_TMP)/rebar; \
  146. cd $(ERLANG_MK_TMP)/rebar; \
  147. git checkout -q 576e12171ab8d69b048b827b92aa65d067deea01; \
  148. $(MAKE); \
  149. cd -; \
  150. fi
  151. endef
  152. define dep_autopatch_rebar
  153. if [ -f $(DEPS_DIR)/$(1)/Makefile ]; then \
  154. mv $(DEPS_DIR)/$(1)/Makefile $(DEPS_DIR)/$(1)/Makefile.orig.mk; \
  155. fi; \
  156. $(call erlang,$(call dep_autopatch_rebar.erl,$(1))); \
  157. rm -f $(DEPS_DIR)/$(1)/ebin/$(1).app
  158. endef
  159. define dep_autopatch_rebar.erl
  160. application:load(rebar),
  161. application:set_env(rebar, log_level, debug),
  162. rmemo:start(),
  163. Conf1 = case file:consult("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config)") of
  164. {ok, Conf0} -> Conf0;
  165. _ -> []
  166. end,
  167. {Conf, OsEnv} = fun() ->
  168. case filelib:is_file("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)") of
  169. false -> {Conf1, []};
  170. true ->
  171. Bindings0 = erl_eval:new_bindings(),
  172. Bindings1 = erl_eval:add_binding('CONFIG', Conf1, Bindings0),
  173. Bindings = erl_eval:add_binding('SCRIPT', "$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings1),
  174. Before = os:getenv(),
  175. {ok, Conf2} = file:script("$(call core_native_path,$(DEPS_DIR)/$1/rebar.config.script)", Bindings),
  176. {Conf2, lists:foldl(fun(E, Acc) -> lists:delete(E, Acc) end, os:getenv(), Before)}
  177. end
  178. end(),
  179. Write = fun (Text) ->
  180. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/Makefile)", Text, [append])
  181. end,
  182. Escape = fun (Text) ->
  183. re:replace(Text, "\\\\$$", "\$$$$", [global, {return, list}])
  184. end,
  185. Write("IGNORE_DEPS += edown eper eunit_formatters meck node_package "
  186. "rebar_lock_deps_plugin rebar_vsn_plugin reltool_util\n"),
  187. Write("C_SRC_DIR = /path/do/not/exist\n"),
  188. Write("C_SRC_TYPE = rebar\n"),
  189. Write("DRV_CFLAGS = -fPIC\nexport DRV_CFLAGS\n"),
  190. Write(["ERLANG_ARCH = ", rebar_utils:wordsize(), "\nexport ERLANG_ARCH\n"]),
  191. fun() ->
  192. Write("ERLC_OPTS = +debug_info\nexport ERLC_OPTS\n"),
  193. case lists:keyfind(erl_opts, 1, Conf) of
  194. false -> ok;
  195. {_, ErlOpts} ->
  196. lists:foreach(fun
  197. ({d, D}) ->
  198. Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  199. ({i, I}) ->
  200. Write(["ERLC_OPTS += -I ", I, "\n"]);
  201. ({platform_define, Regex, D}) ->
  202. case rebar_utils:is_arch(Regex) of
  203. true -> Write("ERLC_OPTS += -D" ++ atom_to_list(D) ++ "=1\n");
  204. false -> ok
  205. end;
  206. ({parse_transform, PT}) ->
  207. Write("ERLC_OPTS += +'{parse_transform, " ++ atom_to_list(PT) ++ "}'\n");
  208. (_) -> ok
  209. end, ErlOpts)
  210. end,
  211. Write("\n")
  212. end(),
  213. fun() ->
  214. File = case lists:keyfind(deps, 1, Conf) of
  215. false -> [];
  216. {_, Deps} ->
  217. [begin case case Dep of
  218. {N, S} when is_atom(N), is_list(S) -> {N, {hex, S}};
  219. {N, S} when is_tuple(S) -> {N, S};
  220. {N, _, S} -> {N, S};
  221. {N, _, S, _} -> {N, S};
  222. _ -> false
  223. end of
  224. false -> ok;
  225. {Name, Source} ->
  226. {Method, Repo, Commit} = case Source of
  227. {hex, V} -> {hex, V, undefined};
  228. {git, R} -> {git, R, master};
  229. {M, R, {branch, C}} -> {M, R, C};
  230. {M, R, {ref, C}} -> {M, R, C};
  231. {M, R, {tag, C}} -> {M, R, C};
  232. {M, R, C} -> {M, R, C}
  233. end,
  234. Write(io_lib:format("DEPS += ~s\ndep_~s = ~s ~s ~s~n", [Name, Name, Method, Repo, Commit]))
  235. end end || Dep <- Deps]
  236. end
  237. end(),
  238. fun() ->
  239. case lists:keyfind(erl_first_files, 1, Conf) of
  240. false -> ok;
  241. {_, Files} ->
  242. Names = [[" ", case lists:reverse(F) of
  243. "lre." ++ Elif -> lists:reverse(Elif);
  244. Elif -> lists:reverse(Elif)
  245. end] || "src/" ++ F <- Files],
  246. Write(io_lib:format("COMPILE_FIRST +=~s\n", [Names]))
  247. end
  248. end(),
  249. Write("\n\nrebar_dep: preprocess pre-deps deps pre-app app\n"),
  250. Write("\npreprocess::\n"),
  251. Write("\npre-deps::\n"),
  252. Write("\npre-app::\n"),
  253. PatchHook = fun(Cmd) ->
  254. case Cmd of
  255. "make -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  256. "gmake -C" ++ Cmd1 -> "$$\(MAKE) -C" ++ Escape(Cmd1);
  257. "make " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  258. "gmake " ++ Cmd1 -> "$$\(MAKE) -f Makefile.orig.mk " ++ Escape(Cmd1);
  259. _ -> Escape(Cmd)
  260. end
  261. end,
  262. fun() ->
  263. case lists:keyfind(pre_hooks, 1, Conf) of
  264. false -> ok;
  265. {_, Hooks} ->
  266. [case H of
  267. {'get-deps', Cmd} ->
  268. Write("\npre-deps::\n\t" ++ PatchHook(Cmd) ++ "\n");
  269. {compile, Cmd} ->
  270. Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  271. {Regex, compile, Cmd} ->
  272. case rebar_utils:is_arch(Regex) of
  273. true -> Write("\npre-app::\n\tCC=$$\(CC) " ++ PatchHook(Cmd) ++ "\n");
  274. false -> ok
  275. end;
  276. _ -> ok
  277. end || H <- Hooks]
  278. end
  279. end(),
  280. ShellToMk = fun(V) ->
  281. re:replace(re:replace(V, "(\\\\$$)(\\\\w*)", "\\\\1(\\\\2)", [global]),
  282. "-Werror\\\\b", "", [{return, list}, global])
  283. end,
  284. PortSpecs = fun() ->
  285. case lists:keyfind(port_specs, 1, Conf) of
  286. false ->
  287. case filelib:is_dir("$(call core_native_path,$(DEPS_DIR)/$1/c_src)") of
  288. false -> [];
  289. true ->
  290. [{"priv/" ++ proplists:get_value(so_name, Conf, "$(1)_drv.so"),
  291. proplists:get_value(port_sources, Conf, ["c_src/*.c"]), []}]
  292. end;
  293. {_, Specs} ->
  294. lists:flatten([case S of
  295. {Output, Input} -> {ShellToMk(Output), Input, []};
  296. {Regex, Output, Input} ->
  297. case rebar_utils:is_arch(Regex) of
  298. true -> {ShellToMk(Output), Input, []};
  299. false -> []
  300. end;
  301. {Regex, Output, Input, [{env, Env}]} ->
  302. case rebar_utils:is_arch(Regex) of
  303. true -> {ShellToMk(Output), Input, Env};
  304. false -> []
  305. end
  306. end || S <- Specs])
  307. end
  308. end(),
  309. PortSpecWrite = fun (Text) ->
  310. file:write_file("$(call core_native_path,$(DEPS_DIR)/$1/c_src/Makefile.erlang.mk)", Text, [append])
  311. end,
  312. case PortSpecs of
  313. [] -> ok;
  314. _ ->
  315. Write("\npre-app::\n\t$$\(MAKE) -f c_src/Makefile.erlang.mk\n"),
  316. PortSpecWrite(io_lib:format("ERL_CFLAGS ?= -finline-functions -Wall -fPIC -I \\"~s/erts-~s/include\\" -I \\"~s\\"\n",
  317. [code:root_dir(), erlang:system_info(version), code:lib_dir(erl_interface, include)])),
  318. PortSpecWrite(io_lib:format("ERL_LDFLAGS ?= -L \\"~s\\" -lerl_interface -lei\n",
  319. [code:lib_dir(erl_interface, lib)])),
  320. [PortSpecWrite(["\n", E, "\n"]) || E <- OsEnv],
  321. FilterEnv = fun(Env) ->
  322. lists:flatten([case E of
  323. {_, _} -> E;
  324. {Regex, K, V} ->
  325. case rebar_utils:is_arch(Regex) of
  326. true -> {K, V};
  327. false -> []
  328. end
  329. end || E <- Env])
  330. end,
  331. MergeEnv = fun(Env) ->
  332. lists:foldl(fun ({K, V}, Acc) ->
  333. case lists:keyfind(K, 1, Acc) of
  334. false -> [{K, rebar_utils:expand_env_variable(V, K, "")}|Acc];
  335. {_, V0} -> [{K, rebar_utils:expand_env_variable(V, K, V0)}|Acc]
  336. end
  337. end, [], Env)
  338. end,
  339. PortEnv = case lists:keyfind(port_env, 1, Conf) of
  340. false -> [];
  341. {_, PortEnv0} -> FilterEnv(PortEnv0)
  342. end,
  343. PortSpec = fun ({Output, Input0, Env}) ->
  344. filelib:ensure_dir("$(call core_native_path,$(DEPS_DIR)/$1/)" ++ Output),
  345. Input = [[" ", I] || I <- Input0],
  346. PortSpecWrite([
  347. [["\n", K, " = ", ShellToMk(V)] || {K, V} <- lists:reverse(MergeEnv(PortEnv))],
  348. case $(PLATFORM) of
  349. darwin -> "\n\nLDFLAGS += -flat_namespace -undefined suppress";
  350. _ -> ""
  351. end,
  352. "\n\nall:: ", Output, "\n\n",
  353. "%.o: %.c\n\t$$\(CC) -c -o $$\@ $$\< $$\(CFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  354. "%.o: %.C\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  355. "%.o: %.cc\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  356. "%.o: %.cpp\n\t$$\(CXX) -c -o $$\@ $$\< $$\(CXXFLAGS) $$\(ERL_CFLAGS) $$\(DRV_CFLAGS) $$\(EXE_CFLAGS)\n\n",
  357. [[Output, ": ", K, " += ", ShellToMk(V), "\n"] || {K, V} <- lists:reverse(MergeEnv(FilterEnv(Env)))],
  358. Output, ": $$\(foreach ext,.c .C .cc .cpp,",
  359. "$$\(patsubst %$$\(ext),%.o,$$\(filter %$$\(ext),$$\(wildcard", Input, "))))\n",
  360. "\t$$\(CC) -o $$\@ $$\? $$\(LDFLAGS) $$\(ERL_LDFLAGS) $$\(DRV_LDFLAGS) $$\(EXE_LDFLAGS)",
  361. case {filename:extension(Output), $(PLATFORM)} of
  362. {[], _} -> "\n";
  363. {_, darwin} -> "\n";
  364. _ -> " -shared\n"
  365. end])
  366. end,
  367. [PortSpec(S) || S <- PortSpecs]
  368. end,
  369. Write("\ninclude $(call core_relpath,$(dir $(ERLANG_MK_FILENAME)),$(DEPS_DIR)/app)/erlang.mk"),
  370. RunPlugin = fun(Plugin, Step) ->
  371. case erlang:function_exported(Plugin, Step, 2) of
  372. false -> ok;
  373. true ->
  374. c:cd("$(call core_native_path,$(DEPS_DIR)/$1/)"),
  375. Ret = Plugin:Step({config, "", Conf, dict:new(), dict:new(), dict:new(),
  376. dict:store(base_dir, "", dict:new())}, undefined),
  377. io:format("rebar plugin ~p step ~p ret ~p~n", [Plugin, Step, Ret])
  378. end
  379. end,
  380. fun() ->
  381. case lists:keyfind(plugins, 1, Conf) of
  382. false -> ok;
  383. {_, Plugins} ->
  384. [begin
  385. case lists:keyfind(deps, 1, Conf) of
  386. false -> ok;
  387. {_, Deps} ->
  388. case lists:keyfind(P, 1, Deps) of
  389. false -> ok;
  390. _ ->
  391. Path = "$(call core_native_path,$(DEPS_DIR)/)" ++ atom_to_list(P),
  392. io:format("~s", [os:cmd("$(MAKE) -C $(call core_native_path,$(DEPS_DIR)/$1) " ++ Path)]),
  393. io:format("~s", [os:cmd("$(MAKE) -C " ++ Path ++ " IS_DEP=1")]),
  394. code:add_patha(Path ++ "/ebin")
  395. end
  396. end
  397. end || P <- Plugins],
  398. [case code:load_file(P) of
  399. {module, P} -> ok;
  400. _ ->
  401. case lists:keyfind(plugin_dir, 1, Conf) of
  402. false -> ok;
  403. {_, PluginsDir} ->
  404. ErlFile = "$(call core_native_path,$(DEPS_DIR)/$1/)" ++ PluginsDir ++ "/" ++ atom_to_list(P) ++ ".erl",
  405. {ok, P, Bin} = compile:file(ErlFile, [binary]),
  406. {module, P} = code:load_binary(P, ErlFile, Bin)
  407. end
  408. end || P <- Plugins],
  409. [RunPlugin(P, preprocess) || P <- Plugins],
  410. [RunPlugin(P, pre_compile) || P <- Plugins],
  411. [RunPlugin(P, compile) || P <- Plugins]
  412. end
  413. end(),
  414. halt()
  415. endef
  416. define dep_autopatch_app.erl
  417. UpdateModules = fun(App) ->
  418. case filelib:is_regular(App) of
  419. false -> ok;
  420. true ->
  421. {ok, [{application, '$(1)', L0}]} = file:consult(App),
  422. Mods = filelib:fold_files("$(call core_native_path,$(DEPS_DIR)/$1/src)", "\\\\.erl$$", true,
  423. fun (F, Acc) -> [list_to_atom(filename:rootname(filename:basename(F)))|Acc] end, []),
  424. L = lists:keystore(modules, 1, L0, {modules, Mods}),
  425. ok = file:write_file(App, io_lib:format("~p.~n", [{application, '$(1)', L}]))
  426. end
  427. end,
  428. UpdateModules("$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"),
  429. halt()
  430. endef
  431. define dep_autopatch_appsrc_script.erl
  432. AppSrc = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  433. AppSrcScript = AppSrc ++ ".script",
  434. Bindings = erl_eval:new_bindings(),
  435. {ok, Conf} = file:script(AppSrcScript, Bindings),
  436. ok = file:write_file(AppSrc, io_lib:format("~p.~n", [Conf])),
  437. halt()
  438. endef
  439. define dep_autopatch_appsrc.erl
  440. AppSrcOut = "$(call core_native_path,$(DEPS_DIR)/$1/src/$1.app.src)",
  441. AppSrcIn = case filelib:is_regular(AppSrcOut) of false -> "$(call core_native_path,$(DEPS_DIR)/$1/ebin/$1.app)"; true -> AppSrcOut end,
  442. case filelib:is_regular(AppSrcIn) of
  443. false -> ok;
  444. true ->
  445. {ok, [{application, $(1), L0}]} = file:consult(AppSrcIn),
  446. L1 = lists:keystore(modules, 1, L0, {modules, []}),
  447. L2 = case lists:keyfind(vsn, 1, L1) of {_, git} -> lists:keyreplace(vsn, 1, L1, {vsn, "git"}); _ -> L1 end,
  448. L3 = case lists:keyfind(registered, 1, L2) of false -> [{registered, []}|L2]; _ -> L2 end,
  449. ok = file:write_file(AppSrcOut, io_lib:format("~p.~n", [{application, $(1), L3}])),
  450. case AppSrcOut of AppSrcIn -> ok; _ -> ok = file:delete(AppSrcIn) end
  451. end,
  452. halt()
  453. endef
  454. define dep_fetch_git
  455. git clone -q -n -- $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  456. cd $(DEPS_DIR)/$(call dep_name,$(1)) && git checkout -q $(call dep_commit,$(1));
  457. endef
  458. define dep_fetch_git-submodule
  459. git submodule update --init -- $(DEPS_DIR)/$1;
  460. endef
  461. define dep_fetch_hg
  462. hg clone -q -U $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1)); \
  463. cd $(DEPS_DIR)/$(call dep_name,$(1)) && hg update -q $(call dep_commit,$(1));
  464. endef
  465. define dep_fetch_svn
  466. svn checkout -q $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  467. endef
  468. define dep_fetch_cp
  469. cp -R $(call dep_repo,$(1)) $(DEPS_DIR)/$(call dep_name,$(1));
  470. endef
  471. # Hex only has a package version. No need to look in the Erlang.mk packages.
  472. define dep_fetch_hex
  473. mkdir -p $(ERLANG_MK_TMP)/hex $(DEPS_DIR)/$1; \
  474. $(call core_http_get,$(ERLANG_MK_TMP)/hex/$1.tar,\
  475. https://s3.amazonaws.com/s3.hex.pm/tarballs/$1-$(strip $(word 2,$(dep_$1))).tar); \
  476. tar -xOf $(ERLANG_MK_TMP)/hex/$1.tar contents.tar.gz | tar -C $(DEPS_DIR)/$1 -xzf -;
  477. endef
  478. define dep_fetch_fail
  479. echo "Error: Unknown or invalid dependency: $(1)." >&2; \
  480. exit 78;
  481. endef
  482. # Kept for compatibility purposes with older Erlang.mk configuration.
  483. define dep_fetch_legacy
  484. $(warning WARNING: '$(1)' dependency configuration uses deprecated format.) \
  485. git clone -q -n -- $(word 1,$(dep_$(1))) $(DEPS_DIR)/$(1); \
  486. cd $(DEPS_DIR)/$(1) && git checkout -q $(if $(word 2,$(dep_$(1))),$(word 2,$(dep_$(1))),master);
  487. endef
  488. define dep_fetch
  489. $(if $(dep_$(1)), \
  490. $(if $(dep_fetch_$(word 1,$(dep_$(1)))), \
  491. $(word 1,$(dep_$(1))), \
  492. $(if $(IS_DEP),legacy,fail)), \
  493. $(if $(filter $(1),$(PACKAGES)), \
  494. $(pkg_$(1)_fetch), \
  495. fail))
  496. endef
  497. define dep_target
  498. $(DEPS_DIR)/$(call dep_name,$1):
  499. $(eval DEP_NAME := $(call dep_name,$1))
  500. $(eval DEP_STR := $(if $(filter-out $1,$(DEP_NAME)),$1,"$1 ($(DEP_NAME))"))
  501. $(verbose) if test -d $(APPS_DIR)/$(DEP_NAME); then \
  502. echo "Error: Dependency" $(DEP_STR) "conflicts with application found in $(APPS_DIR)/$(DEP_NAME)."; \
  503. exit 17; \
  504. fi
  505. $(verbose) mkdir -p $(DEPS_DIR)
  506. $(dep_verbose) $(call dep_fetch_$(strip $(call dep_fetch,$(1))),$(1))
  507. $(verbose) if [ -f $(DEPS_DIR)/$(1)/configure.ac -o -f $(DEPS_DIR)/$(1)/configure.in ] \
  508. && [ ! -f $(DEPS_DIR)/$(1)/configure ]; then \
  509. echo " AUTO " $(1); \
  510. cd $(DEPS_DIR)/$(1) && autoreconf -Wall -vif -I m4; \
  511. fi
  512. - $(verbose) if [ -f $(DEPS_DIR)/$(DEP_NAME)/configure ]; then \
  513. echo " CONF " $(DEP_STR); \
  514. cd $(DEPS_DIR)/$(DEP_NAME) && ./configure; \
  515. fi
  516. ifeq ($(filter $(1),$(NO_AUTOPATCH)),)
  517. $(verbose) if [ "$(1)" = "amqp_client" -a "$(RABBITMQ_CLIENT_PATCH)" ]; then \
  518. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  519. echo " PATCH Downloading rabbitmq-codegen"; \
  520. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  521. fi; \
  522. if [ ! -d $(DEPS_DIR)/rabbitmq-server ]; then \
  523. echo " PATCH Downloading rabbitmq-server"; \
  524. git clone https://github.com/rabbitmq/rabbitmq-server.git $(DEPS_DIR)/rabbitmq-server; \
  525. fi; \
  526. ln -s $(DEPS_DIR)/amqp_client/deps/rabbit_common-0.0.0 $(DEPS_DIR)/rabbit_common; \
  527. elif [ "$(1)" = "rabbit" -a "$(RABBITMQ_SERVER_PATCH)" ]; then \
  528. if [ ! -d $(DEPS_DIR)/rabbitmq-codegen ]; then \
  529. echo " PATCH Downloading rabbitmq-codegen"; \
  530. git clone https://github.com/rabbitmq/rabbitmq-codegen.git $(DEPS_DIR)/rabbitmq-codegen; \
  531. fi \
  532. else \
  533. $$(call dep_autopatch,$(DEP_NAME)) \
  534. fi
  535. endif
  536. endef
  537. $(foreach dep,$(BUILD_DEPS) $(DEPS),$(eval $(call dep_target,$(dep))))
  538. ifndef IS_APP
  539. clean:: clean-apps
  540. clean-apps:
  541. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  542. $(MAKE) -C $$dep clean IS_APP=1 || exit $$?; \
  543. done
  544. distclean:: distclean-apps
  545. distclean-apps:
  546. $(verbose) for dep in $(ALL_APPS_DIRS) ; do \
  547. $(MAKE) -C $$dep distclean IS_APP=1 || exit $$?; \
  548. done
  549. endif
  550. ifndef SKIP_DEPS
  551. distclean:: distclean-deps
  552. distclean-deps:
  553. $(gen_verbose) rm -rf $(DEPS_DIR)
  554. endif
  555. # Forward-declare variables used in core/deps-tools.mk. This is required
  556. # in case plugins use them.
  557. ERLANG_MK_RECURSIVE_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-deps-list.log
  558. ERLANG_MK_RECURSIVE_DOC_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-doc-deps-list.log
  559. ERLANG_MK_RECURSIVE_REL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-rel-deps-list.log
  560. ERLANG_MK_RECURSIVE_TEST_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-test-deps-list.log
  561. ERLANG_MK_RECURSIVE_SHELL_DEPS_LIST = $(ERLANG_MK_TMP)/recursive-shell-deps-list.log
  562. # External plugins.
  563. DEP_PLUGINS ?=
  564. define core_dep_plugin
  565. -include $(DEPS_DIR)/$(1)
  566. $(DEPS_DIR)/$(1): $(DEPS_DIR)/$(2) ;
  567. endef
  568. $(foreach p,$(DEP_PLUGINS),\
  569. $(eval $(if $(findstring /,$p),\
  570. $(call core_dep_plugin,$p,$(firstword $(subst /, ,$p))),\
  571. $(call core_dep_plugin,$p/plugins.mk,$p))))